'\" t
.\"     Title: tkwintrack
.\"    Author: Erik Leunissen
.\" Generator: DocBook XSL Stylesheets v1.79.1 <http://docbook.sf.net/>
.\"      Date: 07/10/2021
.\"    Manual: tkwintrack
.\"    Source: tkwintrack 2.0
.\"  Language: English
.\"
.TH "TKWINTRACK" "n" "07/10/2021" "tkwintrack 2.0" "tkwintrack"
.\" -----------------------------------------------------------------
.\" * Define some portability stuff
.\" -----------------------------------------------------------------
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.\" http://bugs.debian.org/507673
.\" http://lists.gnu.org/archive/html/groff/2009-02/msg00013.html
.\" ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
.ie \n(.g .ds Aq \(aq
.el       .ds Aq '
.\" -----------------------------------------------------------------
.\" * set default formatting
.\" -----------------------------------------------------------------
.\" disable hyphenation
.nh
.\" disable justification (adjust text to left margin only)
.ad l
.\" -----------------------------------------------------------------
.\" * MAIN CONTENT STARTS HERE *
.\" -----------------------------------------------------------------
.SH "NAME"
tkwintrack \- track and outline windows in a Tk GUI, and display their pathname
.SH "SYNOPSIS"
.sp
.nf
\fBpackage require tkwintrack\fR
.fi
.SH "DESCRIPTION"
.PP
The package
tkwintrack
is a little inspection tool for developers of Tk GUI\*(Aqs\&. It extends the interpreter of a Tk application with the machinery to track the individual windows (widgets) in a GUI using the mouse pointer\&. Upon detection of a window, its outline is highlighted and its pathname is displayed in a small separate widget: the
pathname widget\&. Window pathnames displayed in the pathname widget may be copied to the clipboard using a keyboard shortcut\&.
.PP
After loading the package into the client application, tkwintrack starts in configuration mode: a dialog is displayed which lets the user adjust appearance and behaviour of the package\*(Aqs functionality (see also the
section Configuration)\&. After clicking the
Continue
button in this dialog, tkwintrack enters detection mode\&.
Detection mode.PP
In detection mode, the pathname widget appears on screen and the user may track windows using the mouse pointer\&. While moving the mouse around inside the GUI, individual windows are detected, highlighted and their pathname displayed in the pathname widget\&. When the mouse pointer is over the pathname widget, the following mouse button actions are available:
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
right\-clicking opens the configuration dialog\&. This temporarily turns off detection mode\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
pressing and holding the left mouse button allows dragging of the pathname widget\&.
.RE
.PP
The following functionalities are accessible through keyboard shortcuts, irrespective of the position of the mouse pointer or the pathname widget:
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Toggling detection mode off/on\&. Toggling detection mode off withdraws the pathname widget and highlighted window outlines from the screen, thus letting the client GUI resume its unaffected appearance\&. Default keyboard shortcut is
\fBAlt+7\fR\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Copying the pathname of the currently detected window to the clipboard\&. Default keyboard shortcut is
\fBAlt+8\fR\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Recalling the pathname widget\&.
.sp
Recalling the pathname widget is useful in case the pathname widget was configured to not follow the mouse pointer, and the pathname widget was dragged away from the active area of the client application (or conversely)\&. Once that happened, the pathname widget can\*(Aqt be reached anymore with the mouse pointer unless a window in the client application is moved towards the pathname widget\&. The recall keyboard shortcut obviates this awkward action: pressing it moves the pathname widget from anywhere on the screen to the location of the mouse pointer\&. Default keyboard shortcut is
\fBAlt+9\fR\&.
.RE
.PP
The default key sequences for the keyboard shortcuts are rather uncommon\&. This minimizes the probability of interfering with the bindings of the client application\&. Please see
the section called \(lqConfiguration mode\(rq
for how to configure them differently\&.
Configuration mode.PP
Clicking the right mouse button when the mouse pointer is over the pathname widget, displays the configuration dialog\&. It allows the user to adjust appearance and behaviour of various functionalities of the package\&. The following options are available:
.PP
\fBOutline highlighting\fR
.RS 4
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Outline color
.sp
The color used for the outline drawn around a tracked window\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Outline width
.sp
The width of the outline drawn around a tracked window\&. Default is 2 pixels\&.
.RE
.RE
.PP
\fBPathname widget\fR
.RS 4
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Background color
.sp
The background color (fill) of the pathname widget\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Foreground color
.sp
The color of the text and border of the pathname widget\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Follow mouse
.sp
This setting determines whether the pathname widget follows the mouse pointer when a new window is detected\&. Default is on\&.
.RE
.RE
.PP
\fBKeyboard shortcuts\fR
.RS 4
Moving the mouse pointer over the value for a keyboard shortcut (the key sequence) activates key sequence selection mode, and the key sequence becomes highlighted\&. While the value is highlighted, the user can define a new key sequence for the shortcut by pressing keys\&. The shortcut may exist of a single regular key, optionally preceded by one or two modifier keys (Control, Shift, Alt, Meta, Mod1 through Mod5)\&. As soon as a valid key sequence is detected, it is accepted and the key selection mode is deactivated\&.
.RE
.PP
Tkwintrack remembers the settings for up to 10 different client applications\&. Upon loading the package in a client application, tkwintrack automatically applies the settings as they were in the previous session for that specific client application\&. The setting for
follow mouse
is excluded from this memory function: the follow mouse mode is always enabled when tkwintrack starts\&. If the limit of 10 client applications is exceeded, tkwintrack discards the oldest settings\&.
.SH "REQUIREMENTS"
.PP
Tkwintrack has been tested on Linux and MS Windows operating systems\&. It is possible that tkwintrack runs without any problem on the macOS operating system, but this has not been tested, and therefore macOS is not officially supported\&. Running the test script on macOS is expected to reveal whether there are issues on that platform\&.
.PP
Tkwintrack requires Tk 8\&.5 or newer\&. Furthermore, it requires the windetect library 1\&.0\&.
.SH "LIMITATIONS AND KNOWN ISSUES"
.PP
Tkwintrack relies on a client application with a regular Tcl/Tk interpreter, offering standard commands and Tk bindings as provided by the Tcl/Tk language\&. Tkwintrack doesn\*(Aqt cope with situations where standard Tcl/Tk commands were removed or renamed, and it relies on the binding tag
all
being associated with each widget in the client application\&.
.PP
Specific limitations exist for the following functional areas of tkwintrack:
.PP
\fBOutline highlighting\fR. The outline is a composed widget that consists of four lines which are drawn just inside a tracked window\&. Inside these lines the mouse pointer is insensitive to the client GUI, which causes the following oddities:
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Bindings to mouse button actions on the tracked window (defined by the client application) do not work;
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
The mouse cursor may be different from the cursor which the client application configured for the tracked window;
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Very small windows that are completely covered by the outline, cannot be reached or detected if the mouse pointer comes from inside the currently tracked window\&.
.RE
.sp
For these reasons, it is advised to choose the outline width as small as acceptable\&.
.PP
\fBKeyboard shortcuts\fR. If the client application loses input focus, keyboard shortcuts for tkwintrack don\*(Aqt work\&. Therefore, choices with respect to the
\fBfocus\fR
command, made when programming the client application, are relevant for this functionality of tkwintrack\&.
.PP
\fBProgramming constructs that reenter the event loop\fR. Programming constructs in tkwintrack that reenter the event loop may interfere with the order of execution of actions scheduled by the client application\&. During the lifetime of the running program, there are a few occasions where tkwintrack reenters the event loop\&. All except one of these are incidental\&. Specifically:
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
When the pathname widget is created
\fBupdate\ \&idletasks\fR
is called\&. This happens once during the run time of the program, at program initialization\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Each time when the pathname is copied to the clipboard
\fBupdate\ \&idletasks\fR
is called\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Each time when the configuration dialog is (re)displayed, one call to
\fBupdate\ \&idletasks\fR
and one call to
\fBtkwait\ \&visibility\fR
are made\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
Each time when an invalid keyboard shortcut is entered in the configuration dialog,
\fBupdate\ \&idletasks\fR
is called\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
If the pathname widget follows the mouse,
\fBupdate\ \&idletasks\fR
is called each time when a new window is detected\&. This is the only case that occurs while operating the mouse to track windows, and it can be prevented by configuring tkwintrack to not follow the mouse\&.
.RE
.SH "TEST SCRIPT"
.PP
Tkwintrack comes with a test script
tkwintrack\&.test, which is invoked as follows:
.sp
.if n \{\
.RS 4
.\}
.nf
\fBtclsh tkwintrack\&.test \fR\fB\fI?option value? ?option value? \&.\&.\&.\fR\fR
.fi
.if n \{\
.RE
.\}
.PP
or, on unix\-derived operating systems, if the script file has been made executable:
.sp
.if n \{\
.RS 4
.\}
.nf
\fBtkwintrack\&.test \fR\fB\fI?option value? ?option value? \&.\&.\&.\fR\fR
.fi
.if n \{\
.RE
.\}
.PP
There are two types of option\-value pairs that the command line accepts:
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
configuration options for the Tcl test harness
tcltest\&. These are passed on to
tcltest\&. Please see the documentation for package
tcltest
for details\&.
.RE
.sp
.RS 4
.ie n \{\
\h'-04'\(bu\h'+03'\c
.\}
.el \{\
.sp -1
.IP \(bu 2.3
.\}
configuration options specific to testing of
tkwintrack\&. Currently, there is just one such option:
\fI\-\&wtune\fR\&.
.sp
The function of this option is to adjust waiting times, used by various tests in the test script\&. Many tests have a stage where the redrawing of the screen needs to be completed before proceeding\&. Note that the test script runs without any user\-\&interaction, and the commands
\fBtkwait\ \&visibility\fR
or
\fBupdate\ \&idletasks\fR
cannot always be used, or are to no avail\&. In such situations, tkwintrack relies on an estimate of the time needed for the screen update\&. This is awkward because the time required for a screen update to complete depends on system performance, something that can change even while tests are running\&. The estimated waiting times are very generic and course\-\&grained\&. Although they tend to stay on the safe side, they may not meet the needs in specific circumstances, especially on less performant systems\&.
.sp
To address this situation, the waiting times for screen updates have been made adjustable\&. Adjusting is done by using the option
\fI\-\&wtune\ \&numval\fR, which affects the waiting times for all tests in the test script in the same way\&. The default value for
\fInumval\fR
is 1\&.0\&. The higher the value for
\fInumval\fR, the longer the waiting time\&.
.sp
If tests are failing because of waiting times that are too short, it is advised to retry the script execution with a higher value for
\fInumval\fR\&. Typical symptoms of tests failing for this reason are background errors and hangs (the event loop stalls)\&.
.RE
.SH "AUTHOR"
.PP
Erik Leunissen
.SH "SEE ALSO"
.PP
bind(n), bindtags(n), focus(n), tcltest(n), tkwait(n), update(n), windetect(n)
.SH "LICENSE"
.PP
Copyright \(co 2020 Erik Leunissen\&.
.PP
Licensed under the Apache License, Version 2\&.0 (the "License"); you may not use this file except in compliance with the License\&. You may obtain a copy of the License at:
.PP
http://www\&.apache\&.org/licenses/LICENSE\-2\&.0
.PP
Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied\&. See the License for the specific language governing permissions and limitations under the License\&.
